//  CalendarGraphics.h by T. Yamagata
//  Last Update 981231
#ifndef _CALENDAR_GRAPHICS_H							//981124
#define _CALENDAR_GRAPHICS_H							//981124
#include <interface/Point.h>							//981030
#include <interface/View.h>								//981030
#include <interface/Bitmap.h>							//981226
#include "CalendarView.h"								//981205		

class StringLabel;
float	GetFontSize(float width, float thresh[4], float sizeList[5]);
																//981203
int32	GetSizeIndex(float width);								//981209
void	GetDateString(char *dateString);						//981231

//---- MonthGraphic -----------------------------------------------------------
class DrawView : public BView									//981226
{
public:															//981226
					DrawView(BRect frame, TimerView *parent);	//981227
	void			DrawX();									//981231
	virtual void	AttachedToWindow();							//981231
private:														//981227
	TimerView *		p;											//981227
};																//981226

class TimerView : public BView									//981203
{																//981203
public:															//981203
					TimerView(BRect frame, char *name,			//981205 
						CalendarView *parent);					//981203
	virtual			~TimerView();								//981226
	virtual void	FrameResized(float new_width, float new_height);
	virtual void	Invalidate();
	virtual void	Draw(BRect  updateRect);					//981203
	virtual void	SetSize(BPoint size);						//981205
	virtual void	CalculateMonthLabels();	
	virtual void	AttachedToWindow();							//981231
	void			Pulse();									//981209
	CalendarView	*p;
	StringLabel		*fdateLabel;
	DrawView		*drawView;									//981226
private:														//981203
	BPoint			fSize;				// Size of the graphic
	BBitmap			*offscreen;									//981231
};																//981203

class DaysView													//981226
{																//981203
public:															//981203
					DaysView(CalendarView *parent );			//981226
	//virtual			~DaysView();							//981203	
	virtual void	FrameResized(float new_width, float new_height);
	virtual void	Invalidate();
	virtual void	Draw(BRect updateRect);						//981203
	virtual void	SetSize(BPoint size);						//981205
//private:														//981203
//	float			ftSize;										//981203
protected:
	virtual void		Init();
	virtual void 		CalibrateFontSizes(const int32 sizeIndex);
	virtual void		CalculateFontSizes();
	virtual void		CalculateColumnLabel(StringLabel&,int32);
	virtual void		CalculateDaysLabels();
	virtual void		CalculateParameters();
	virtual StringLabel *	CreateDayLabel(const int32 column);

private:			
	CalendarView	*p;
	BPoint 			GridTopLeft;
	//BPoint			GridCellSize;
	BPoint			GridBottomRight;
	BRect 			GridRect;
	BPoint			fSize;			// Size of the graphic

	char 			**fDayNameArray;
	long			fSizeIndex;	
	bool			fImageNeedsUpdate;

    // The String labels
	StringLabel	*fColumn0Label;
	StringLabel	*fColumn1Label;
	StringLabel	*fColumn2Label;
	StringLabel	*fColumn3Label;
	StringLabel	*fColumn4Label;
	StringLabel	*fColumn5Label;
	StringLabel	*fColumn6Label;
	StringLabel	*GDayTextArray[32];
};																//981203


#endif